version: 0.2

phases:
  install:
    runtime-versions:
      nodejs: latest
    commands:
      - echo Installing dependencies...
      - npm install

  pre_build:
    commands:
      - echo Logging in to Amazon ECR...
      - aws ecr get-login-password --region $AWS_DEFAULT_REGION | docker login --username santosh7046 --password-stdin $ECR_REGISTRY
      - echo Pulling PostgreSQL image...
      - docker pull postgres:latest
  build:
    commands:
      - echo Setting up PostgreSQL service...
      - docker run --name postgres -e POSTGRES_PASSWORD=password -d postgres:13-alpine
      - sleep 10
      - docker exec -it postgres createdb resid
      - echo Building Resid project...
      - npm run build
      - npm run test

  post_build:
    commands:
      - echo Tagging and pushing Docker image to ECR...
      - docker tag resid $ECR_REGISTRY/resid:$CODEBUILD_RESOLVED_SOURCE_VERSION
      - docker push $ECR_REGISTRY/resid:$CODEBUILD_RESOLVED_SOURCE_VERSION
      - echo Cleaning up...
      - docker stop postgres
      - docker rm postgres

artifacts:
  files:
    - './src/*'
  name: resid
